Data "1 4 0 7 - B l i t z 1 V 5 "              'Prog-Name im .hex-File
'  1407-Blitz1V5, der Einzeller
'  1,55 Volt/~500uA Gewitterwarner fr die Hemdentasche
'  dieses Programm dient Ausbildungszwecken
'  #############################################################################
'  ATTiny13 20PU
'  1 /Reset/B5/Ad0
'  2 B3/Ad3              -> Piezo
'  3 B4/Ad2              <- TA7642
'  4 GND
'  5 B0/mosi/oc0a                   -> Led rot
'  6 B1/miso/Int0/oc0b              -> Led gelb
'  7 B2/Sck/Ad1/T0       -> Piezo + -> Led grn
'  8 +Vcc                <- 300uA, -> 2k2, TA7642 (~200uA)
'  #############################################################################
'$prog &HFF , &H6A , &HFF , &H00                '1,2MHz ~400uA
'$prog &HFF , &H69 , &HFF , &H00                '600kHz ~300uA
$crystal = 1200000                             'ab Werk
$crystal = 600000
$regfile = "attiny13.dat"
$hwstack = 16
$swstack = 16
$framesize = 16
$programmer = 19                               'USBASP

Stop Watchdog : Stop Ac                        ' Strom sparen
Ddrb = &B01111
Rot Alias Portb.0
Gelb Alias Portb.1
Gruen Alias Portb.2                            ' +Piezo
Piezo Alias Portb.3
Ta7642 Alias Getadc(2)                         'B4

Config Adc = Free , Prescaler = Auto , Reference = Avcc
Dim Mittelwert As Integer
Dim Aktuell As Integer
Dim Schwelle As Integer
Dim Tonzeit As Byte                            ' Tonezeit
Dim Blitz As Word                              ' Blitzzhler
Dim Reduce As Word                             ' ~45s

Do                                             ' ~0,7ms/loop
   Mittelwert = Mittelwert + Aktuell
   Mittelwert = Mittelwert / 2
   Aktuell = Ta7642                            ' Getadc
   Schwelle = Mittelwert - 3                   ' (n+1) * 1,5mV
' negativer Puls aufgetreten ?
   If Aktuell < Schwelle Then
      Tonzeit = 255                            ' Blitzzeit ein
      Incr Blitz                               ' Blitzzhler = Warnstufe
      Piezo = 1 : Gruen = 0                    ' init
'      Waitms 50                                ' zur Trennung
   End If
' Piezo/Led einschalten ?
   If Tonzeit = 0 Then
      Piezo = 0 : Gruen = 0                    ' aus
   Else
      Toggle Piezo : Toggle Gruen              ' ein
      Decr Tonzeit                             ' alle ~0,7ms runterzhlen
   End If
' optional: rote/gelbe Led einschalten ? ---------------------------------------
   If Blitz > 20 Then                          ' Led rot ?
      Toggle Rot
   Else
      Rot = 0
      If Blitz > 2 Then Toggle Gelb Else Gelb = 0       ' Led gelb ?
   End If
' Schleifenzhler zur Reduzierung der Warnstufe fr gelb/rot
   If Reduce = 0 And Blitz > 0 Then Decr Blitz
   Decr Reduce                                 ' alle ~0,7ms runterzhlen
Loop
'end ---------------------------------------------------------------------------